using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace gbweb
{
	/// <summary>
	/// Summary description for Admin.
	/// </summary>
	public class Admin : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.LinkButton hlSubmit;
		protected System.Web.UI.WebControls.DropDownList dropdownThemes;
		protected System.Web.UI.HtmlControls.HtmlInputText txtTimelineRepeat;
		protected System.Web.UI.HtmlControls.HtmlInputText txtMinuteSlice;
		protected System.Web.UI.HtmlControls.HtmlInputText txtMinuteInterval;
		protected System.Web.UI.HtmlControls.HtmlInputText txtMinuteSpan;
		protected System.Web.UI.WebControls.HyperLink hlReset;
		protected System.Web.UI.WebControls.DropDownList dropdownRecordingQuality;
		protected System.Web.UI.HtmlControls.HtmlInputText mimeType;
		protected System.Web.UI.WebControls.RadioButtonList showGenre;
		protected System.Web.UI.WebControls.CheckBox showRepeat;
		protected System.Web.UI.WebControls.CheckBox showCredits;
		protected System.Web.UI.WebControls.CheckBox showIMDB;
		protected System.Web.UI.WebControls.CheckBox showNetflix;
		protected System.Web.UI.WebControls.CheckBox showRating;
		protected System.Web.UI.WebControls.CheckBox showDescription;
		protected System.Web.UI.WebControls.CheckBox showSubtitle;
		protected System.Web.UI.WebControls.CheckBox UseChannelIcons;
		protected System.Web.UI.WebControls.LinkButton sizeDefault;
		protected System.Web.UI.HtmlControls.HtmlInputText playlistExtension;
		protected System.Web.UI.HtmlControls.HtmlInputText txtChnlIconH;
		protected System.Web.UI.HtmlControls.HtmlInputText txtChnlIconW;
		protected System.Web.UI.HtmlControls.HtmlGenericControl spanZapEPG;
		protected System.Web.UI.HtmlControls.HtmlGenericControl spanZapTools;
		protected System.Web.UI.WebControls.TextBox txtAutologinList;
		protected System.Web.UI.WebControls.LinkButton hlAutologinInternal;
		protected System.Web.UI.WebControls.LinkButton hlAutologinNone;
		protected System.Web.UI.WebControls.Label lblAutologinWarning;
	
		private Settings guideParams;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (User.Identity.Name.Length == 0)
				{
					FormsAuthentication.SignOut();
					Response.Redirect("Login.aspx?ReturnUrl=" + HttpUtility.UrlEncode(Request.Url.PathAndQuery));
				}

			guideParams = Global.Settings;

			if (!IsPostBack) 
			{
				string[] themes = Directory.GetDirectories(Server.MapPath(Request.ApplicationPath + "/themes/"));
				foreach (string theme in themes)
				{
					if (File.Exists(Path.Combine(theme, "styles.css")))
					{
						dropdownThemes.Items.Add(Path.GetFileName(theme));
					}
				}
			
				txtMinuteSpan.Value						= guideParams.minuteSpan.ToString();
				txtMinuteInterval.Value					= guideParams.minuteInterval.ToString();
				txtMinuteSlice.Value					= guideParams.minuteSlice.ToString();
				txtTimelineRepeat.Value					= guideParams.timelineRepeat.ToString();
				dropdownRecordingQuality.SelectedValue	= guideParams.recordingQuality.ToString();
				if (dropdownThemes.Items.FindByValue(guideParams.theme) != null)
					dropdownThemes.SelectedValue		= guideParams.theme;
				showDescription.Checked					= guideParams.showDescription;
				showDescription.Checked					= guideParams.showDescription;
				showSubtitle.Checked					= guideParams.showSubtitle;
				showGenre.SelectedValue					= guideParams.showGenre;
				showRating.Checked						= guideParams.showRating;
				showRepeat.Checked						= guideParams.showRepeat;
				showIMDB.Checked						= guideParams.showIMDB;
				showNetflix.Checked						= guideParams.showNetflix;
				showCredits.Checked						= guideParams.showCredits;
				UseChannelIcons.Checked					= guideParams.useChannelIcons;
				playlistExtension.Value					= guideParams.playlistExtension;
				txtChnlIconH.Value						= guideParams.channelIconHeight;
				txtChnlIconW.Value						= guideParams.channelIconWidth;
				txtAutologinList.Text					= guideParams.autologinNetworks;

				spanZapEPG.Visible = ZapTools.checkZapEPG();
				spanZapTools.Visible = ZapTools.Initialize();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sizeDefault.Click += new System.EventHandler(this.sizeDefault_Click);
			this.hlAutologinInternal.Click += new System.EventHandler(this.hlAutologinInternal_Click);
			this.hlAutologinNone.Click += new System.EventHandler(this.hlAutologinNone_Click);
			this.hlSubmit.Click += new System.EventHandler(this.hlSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void hlSubmit_Click(object sender, System.EventArgs e)
		{
			guideParams.minuteSpan			= Convert.ToInt32(txtMinuteSpan.Value);
			guideParams.minuteInterval		= Convert.ToInt32(txtMinuteInterval.Value);
			guideParams.minuteSlice			= Convert.ToInt32(txtMinuteSlice.Value);
			guideParams.timelineRepeat		= Convert.ToInt32(txtTimelineRepeat.Value);
			guideParams.theme				= dropdownThemes.SelectedValue;
			guideParams.recordingQuality	= dropdownRecordingQuality.SelectedValue;
			guideParams.showDescription		= showDescription.Checked;
			guideParams.showSubtitle		= showSubtitle.Checked;
			guideParams.showGenre			= showGenre.SelectedValue;
			guideParams.showRating			= showRating.Checked;
			guideParams.showRepeat			= showRepeat.Checked;
			guideParams.showIMDB			= showIMDB.Checked;
			guideParams.showNetflix			= showNetflix.Checked;
			guideParams.showCredits			= showCredits.Checked;
			guideParams.useChannelIcons		= UseChannelIcons.Checked;
			guideParams.playlistExtension	= playlistExtension.Value;
			guideParams.channelIconHeight	= txtChnlIconH.Value;
			guideParams.channelIconWidth	= txtChnlIconW.Value;
			guideParams.autologinNetworks	= txtAutologinList.Text;

			Global.Settings.Save();

			string[] invalidAutologinNetworks = guideParams.ParseAutologinNetworks();
			if (invalidAutologinNetworks.Length > 0)
			{
				lblAutologinWarning.Text = "WARNING: Invalid ranges: " + string.Join(",", invalidAutologinNetworks);
			} 
			else 
			{
				lblAutologinWarning.Text = string.Empty;
			}
		}

		private void sizeDefault_Click(object sender, System.EventArgs e)
		{
			txtChnlIconH.Value = string.Empty;
			txtChnlIconW.Value = string.Empty;
		}

		private void hlAutologinInternal_Click(object sender, System.EventArgs e)
		{
			txtAutologinList.Text = "127.0.0.0/8,10.0.0.0/8,172.16.0.0/12,192.168.0.0/16,169.254.0.0/16";
		}

		private void hlAutologinNone_Click(object sender, System.EventArgs e)
		{
			txtAutologinList.Text = "none";
		}
	}
}
