<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" />

	<xsl:template match="/">
		<xsl:element name="html">
			<head>
				<title>GBPVR - Change Log</title>
				<meta name="GENERATOR" Content="Microsoft Visual Studio .NET 7.1"/>
				<meta name="CODE_LANGUAGE" Content="C#"/>
				<meta name="vs_defaultClientScript" content="JavaScript"/>
				<meta name="vs_targetSchema" content="http://schemas.microsoft.com/intellisense/ie5"/>
				<style type="text/css">
					.blackText {font-family:verdana,arial;color:#000000;}
					.largeBlackText {font-family:verdana,arial;font-size:20px;color:#000000;align=center;font-weight:bold;}
					.borders {border-left:1px solid #000000;border-right:1px solid #000000;border-top:1px solid #000000;border-bottom:1px solid #000000;}
				</style>
			</head>
			<xsl:apply-templates select="changelog"/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="changelog">
		<body bgcolor="#DDDDDD">
			<span class="largeBlackText">GBPVR Web Admin Change Log</span>
			<hr/>
			<xsl:apply-templates select="build"/>
		</body>
	</xsl:template>

	<xsl:template match="build">
		<p>
			<table class="borders" border="1" width="450" cellpadding="0" cellspacing="0">
				<tr class="blackText" bgcolor="#FFCCAA">
					<td><b>Date:</b></td>
					<td>
						<xsl:value-of select="@release_date"/>
					</td>
					<td><b>Build Number:</b></td>
					<td>
						<xsl:value-of select="@build_number"/>
					</td>
				</tr>
				<tr>
					<td colspan="4" bgcolor="#FF99CC"><b>Changes:</b></td>
				</tr>
				<tr>
					<td colspan="4">
						<ul>
							<xsl:apply-templates select="changes"/>
						</ul>
					</td>
				</tr>
			</table>
		</p>
	</xsl:template>
	
	<xsl:template match="change">
		<xsl:element name="li">
			<xsl:attribute name="title">Contributed by: <xsl:value-of select="@author"/></xsl:attribute>
			<xsl:value-of select="."/>
		</xsl:element>
	</xsl:template>

</xsl:stylesheet>
